Global stage, expected, header$, recipient, client, version$
Global smtpLog  As Integer
Global Const client_smtp = 1
Global Const client_finger = 2
Global helptext$, helpcaption$
Global nl As String
Type recordType
  Size As Integer
  position As Integer
End Type

Sub addToQueue (filename$, a$)
  Dim x, y, msgSize  As Integer, numberOfRecords
  Dim record As recordType
'
  x = FreeFile
  Open app.Path + "\" + filename$ + ".txt" For Append As #x
  record.position = Seek(x)
  Print #x, a$;
  y = Seek(x)
  Close #x
  x = FreeFile
  Open app.Path + "\" + filename$ + ".idx" For Random As #x Len = Len(record)
  numberOfRecords = LOF(x) \ Len(record)
  record.Size = Len(a$)
  Put #x, numberOfRecords + 1, record
  Close #x

End Sub

Function exist (Path$)
Dim x
    x = FreeFile

    On Error Resume Next
    Open Path$ For Input As x
    If Err = 0 Then
      exist = True
    Else
      exist = False
    End If
    Close x


End Function

Function loadFromMailQueue (filename$)
  file$ = app.Path + "\" + filename$ + ".idx"
  If exist(file$) Then 'check for record file
      Dim a$, x, y, i%, posit As Integer, numberOfRecords As Integer
      Dim record As recordType
      nl = Chr$(13) + Chr$(10)
      x = FreeFile
      Open file$ For Random As #x Len = Len(record)
      numberOfRecords = LOF(x) \ Len(record)
      Get #x, numberOfRecords, record
      If numberOfRecords > 1 Then 'Make another record file with 1 rec less
	If exist(app.Path + "temp.idx") Then Kill app.Path + "temp.idx"
	y = FreeFile
	Open app.Path + "temp.idx" For Random As #y Len = Len(record)
	For i% = 1 To numberOfRecords - 1
	  Get #x, i%, record
	  Put #y, i%, record
	Next
	Get #x, numberOfRecords, record
	Close #x
	Close #y
	Kill app.Path + "\outqueue.idx"
	Name app.Path + "temp.idx" As file$
	'Kill app.Path + "temp.idx"
      Else
	Close #x
	Kill file$
      End If

      x = FreeFile
      Open app.Path + "\outqueue.txt" For Input As #x
      Seek #x, record.position
      a$ = Input$(record.Size, #x)
      Close #x
      If numberOfRecords < 2 Then
	Kill app.Path + "\outqueue.txt"
      End If
      posit = InStr(a$, nl)
      form1.Text2.Text = Left$(a$, posit - 1)
      a$ = Mid$(a$, posit + 2)

      posit = InStr(a$, nl)
      form1.Text3.Text = Left$(a$, posit - 1)
      a$ = Mid$(a$, posit + 2)

      posit = InStr(a$, nl)
      form1.Text4.Text = Left$(a$, posit - 1)
      a$ = Mid$(a$, posit + 2)
  
      form1.Text1.Text = a$
      loadFromMailQueue = True
  Else
    loadFromMailQueue = False
  End If

End Function

Function messagesInMailQueue ()
    file$ = app.Path + "\outqueue.idx"
    Dim record As recordType, x
    x = FreeFile
    Open file$ For Random As #x Len = Len(record)
    messagesInMailQueue = LOF(x) \ Len(record)
    Close


End Function

Function rubbish (x As Integer) As String
  Dim i%, a$
  For i% = 1 To x
    a$ = a$ + Chr$(Int(Rnd * 94) + 33)
  Next
  rubbish = a$
End Function

Sub sendToSocket (a$)

  On Error Resume Next
  If smtpLog = True Then
    form1.Text1.SelLength = 0
    form1.Text1.SelStart = 30000
    form1.Text1.SelText = a$
  End If
  form1.Socket1.SendLen = Len(a$)
  form1.Socket1.SendData = a$
  


End Sub

Sub smtp_handler (sBuffer)
  Dim a$, b$, nl, y, file$
  nl = Chr$(13) + Chr$(10)
  If smtpLog = True Then
    form1.Text1.SelLength = 0
    form1.Text1.SelStart = 30000
    form1.Text1.SelText = sBuffer + nl
  End If
  On Error Resume Next
  If expected = Val(Left$(sBuffer, 3)) Then
    Select Case stage
      Case Is = 1
	a$ = "HELO anonpost" + nl
	stage = 2
	expected = 250
	Call sendToSocket(a$)
      Case Is = 2
	a$ = "MAIL FROM: " + "<" + Trim$(form1.email_address.Text) + ">" + nl
	stage = 3
	expected = 250
	sendToSocket a$
      Case Is = 3
	a$ = "RCPT TO: " + "<" + recipient + ">" + nl
	stage = 4
	expected = 250
	sendToSocket a$
      Case Is = 4
	a$ = "DATA" + nl
	stage = 5
	expected = 354
	sendToSocket a$
      Case Is = 5
	form1.Caption = "Sending mail to " + recipient
	stage = 6
	expected = 250
	form1.Socket1.Blocking = True
	' Now load in the headers and message body
	x = FreeFile
	Open app.Path + "\mailout.bdy" For Input As #x
	Do While Not EOF(x)
	    Line Input #x, a$
	    If Left$(a$, 1) = "." Then
		a$ = "." + a$
	    End If
	    If smtpLog = True Then
	      form1.Text1.SelLength = 0
	      form1.Text1.SelStart = 30000
	      form1.Text1.SelText = a$ + nl
	    End If
	    form1.Socket1.SendLen = Len(a$) + 2
	    form1.Socket1.SendData = a$ + nl
	    DoEvents
	    Do While form1.Socket1.IsBlocked
		DoEvents
	    Loop
	Loop
	Close #x
	DoEvents
	form1.Socket1.Blocking = False
	a$ = "." + nl
	sendToSocket (a$)
	
      Case Is = 6
	a$ = "QUIT" + nl
	stage = 7
	expected = 221
	sendToSocket a$
      Case Is = 7
	
	  Screen.MousePointer = 0
	  form1.Socket1.Action = SOCKET_CLOSE
	  form1.Socket1.Action = SOCKET_CLEANUP
	  form1.Caption = "AnonPost " + version$
	  MsgBox "Mail to " + recipient + " successfuly sent", 48
	  form1.Label2 = ""
	  file$ = app.Path + "\logfile.txt"
	  If exist(file$) Then trash file$
      
      Case Else
      End Select
  Else
    MsgBox "SMTP Error at " + Str$(Val(stage)) + " " + sBuffer
  End If



End Sub

Sub trash (a$)
  Dim x
  x = FreeFile
  Open a$ For Append As #x
  Seek #x, 1
  Print #x, rubbish(LOF(x))
  Close #x
  Kill a$
End Sub

